    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------
    028     * PointerNeedle.java
    029     * ------------------
    030     * (C) Copyright 2002-2006, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: PointerNeedle.java,v 1.4.2.3 2006/08/02 10:40:57 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 26-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.GeneralPath;
    051    import java.awt.geom.Point2D;
    052    import java.awt.geom.Rectangle2D;
    053    import java.io.Serializable;
    054
    055    /**
    056     * A needle in the shape of a pointer, for use with the
    057     * {@link org.jfree.chart.plot.CompassPlot} class.
    058     */
    059    public class PointerNeedle extends MeterNeedle
    060                               implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -4744677345334729606L;
    064
    065        /**
    066         * Draws the needle.
    067         *
    068         * @param g2  the graphics device.
    069         * @param plotArea  the plot area.
    070         * @param rotate  the rotation point.
    071         * @param angle  the angle.
    072         */
    073        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    074                                  Point2D rotate, double angle) {
    075
    076            GeneralPath shape1 = new GeneralPath();
    077            GeneralPath shape2 = new GeneralPath();
    078            float minX = (float) plotArea.getMinX();
    079            float minY = (float) plotArea.getMinY();
    080            float maxX = (float) plotArea.getMaxX();
    081            float maxY = (float) plotArea.getMaxY();
    082            float midX = (float) (minX + (plotArea.getWidth() / 2));
    083            float midY = (float) (minY + (plotArea.getHeight() / 2));
    084
    085            shape1.moveTo(minX, midY);
    086            shape1.lineTo(midX, minY);
    087            shape1.lineTo(maxX, midY);
    088            shape1.closePath();
    089
    090            shape2.moveTo(minX, midY);
    091            shape2.lineTo(midX, maxY);
    092            shape2.lineTo(maxX, midY);
    093            shape2.closePath();
    094
    095            if ((rotate != null) && (angle != 0)) {
    096                /// we have rotation huston, please spin me
    097                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    098                shape1.transform(getTransform());
    099                shape2.transform(getTransform());
    100            }
    101
    102            if (getFillPaint() != null) {
    103                g2.setPaint(getFillPaint());
    104                g2.fill(shape1);
    105            }
    106
    107            if (getHighlightPaint() != null) {
    108                g2.setPaint(getHighlightPaint());
    109                g2.fill(shape2);
    110            }
    111
    112            if (getOutlinePaint() != null) {
    113                g2.setStroke(getOutlineStroke());
    114                g2.setPaint(getOutlinePaint());
    115                g2.draw(shape1);
    116                g2.draw(shape2);
    117            }
    118        }
    119
    120        /**
    121         * Tests another object for equality with this object.
    122         *
    123         * @param obj  the object to test (<code>null</code> permitted).
    124         *
    125         * @return A boolean.
    126         */
    127        public boolean equals(Object obj) {
    128            if (obj == this) {
    129                return true;
    130            }
    131            if (!(obj instanceof PointerNeedle)) {
    132                return false;
    133            }
    134            if (!super.equals(obj)) {
    135                return false;
    136            }
    137            return true;
    138        }
    139
    140        /**
    141         * Returns a clone of this needle.
    142         *
    143         * @return A clone.
    144         *
    145         * @throws CloneNotSupportedException if the <code>PointerNeedle</code>
    146         *     cannot be cloned (in theory, this should not happen).
    147         */
    148        public Object clone() throws CloneNotSupportedException {
    149            return super.clone();
    150        }
    151
    152    }